#ifndef __RZB_API_H__
#define __RZB_API_H__

#include <uuid/uuid.h>
#include "rzb_global.h"

/* API UUID Set */
#define PDF_DOC_API "005d5464-7a44-4907-af57-4db08a61e13c"
#define MAIL_CAP_API "d147f215-128e-4746-a1e2-b6c978bb1869"
#define ANY_DATA_API "00000000-0000-0000-0000-000000000000"


typedef struct _handlerNode
{
    void (*fp)(BLOCK_META_DATA *metaData);
    uuid_t *acceptedTypes;
    size_t numTypes;
    uuid_t functionid;
    struct _handlerNode *next;
} handlerNode;

extern handlerNode *head;

HRESULT rzbRegisterHandler(handler_fp fp, const uuid_t *acceptedTypes, size_t numTypes,
                           const uuid_t nuggetType);

/*HRESULT sendAlert(unsigned      alertid,
                  char            *alertmsg,
                  unsigned        metacode,
                  unsigned        metasize,
                  void            *metadata);
*/

HRESULT sendData(BLOCK_META_DATA *metaData);


HRESULT AlertsDone(unsigned eventid);

HRESULT registerNugget(const uuid_t nugtype,
                       const uuid_t nugapp,
                       const uuid_t datatype,
                       unsigned short nugport,
                       unsigned instances,
                       unsigned nugid,
                       const char *name,
                       unsigned *nuggetid);

BLOCK_META_DATA *initMetaData(void);
HRESULT rzbServer(const char *port, rzb_thread_func_t func, unsigned to_secs);

typedef struct _COLLECTIONAPI
{
    check_resource_fp   checkResource;
    send_data_fp        sendData;
    send_meta_data_fp   sendMetaData;
    register_nugget_fp  registerNugget;
} CollectionAPI;

extern const CollectionAPI rzb_collector;

#endif  /* __RZB_API_H__ */
