#include <getopt.h>

#include "config.h"
#include "rzb_dispatcher.h"
#include "rzb_conf.h"
#include "rzb_client.h"

int main(int argc, char *argv[])
{
    static const struct option long_options[] =
    {
        {"conf",required_argument, NULL, 'c'},
        {NULL, 0, NULL, 0}
    };

    int optId; /* holds the option index for getopt*/
    const char *configFile;
    int option_index = 0;

    configFile = "rzb.conf";

    for (;;)
    {
        optId = getopt_long(argc, argv, "c:", long_options, &option_index);

        if (optId == -1)
            break;

        switch (optId)
        {
            case 'c':
                configFile = optarg;
                break;
            case '?':  /* getopt errors */
                break;
            default:
                break;
        }
    }

    readConfig(&nrtconfig, configFile);

    dispatchServer(nrtconfig.dsrvport);

    return 0;
}
