#include <netinet/in.h>
#include <arpa/inet.h>
#include <getopt.h>

#include "config.h"
#include "rzb_intel_global.h"
#include "rzb_intel_api.h"
#include "rzb_global.h"
#include "rzb_network.h"
#include "rzb_client.h"
#include "rzb_api.h"
#include "rzb_conf.h"

#define SRC_IP "192.168.1.6"
#define DST_IP "204.11.59.2"
#define HOST_DATA "test.host.com"
#define USER_AGENT_DATA "FIREFOX"
#define COOKIE_DATA "cookie"
#define HEADER_DATA "FULL HEADER DATA"
#define URL_DATA "page.html"

int main(int argc, char ** argv)
{
    WEB_ENTRY data;

    static const struct option long_options[] =
    {
        {"conf",required_argument, NULL, 'c'},
        {NULL, 0, NULL, 0}
    };

    int optId; /* holds the option index for getopt*/
    const char *configFile = "rzb.conf";
    int option_index = 0;

    while (1)
    {
        optId = getopt_long(argc, argv, "c:", long_options, &option_index);

        if (optId == -1)
            break;

        switch (optId)
        {
            case 'c':
                configFile = optarg;
                break;
            case '?':  /* getopt errors */
                break;
            default:
                break;
        }
    }

    readConfig(&nrtconfig, configFile);

    inet_pton(AF_INET, SRC_IP, &data.src_ip);
    inet_pton(AF_INET, DST_IP, &data.dst_ip);
    snprintf(data.url, sizeof(data.url), "%s", URL_DATA);
    snprintf(data.host, sizeof(data.host), "%s", HOST_DATA);
    snprintf(data.cookie, sizeof(data.cookie), "%s", COOKIE_DATA);
    snprintf(data.user_agent, sizeof(data.user_agent), "%s", USER_AGENT_DATA);

    printf("<===WEB TRACKER TEST===>");
    sendWebTrack(&data);
    printf("<===DATA SENT--->");

    return 0;
}
