#include <getopt.h>

#include "config.h"
#include "rzb_global.h"
#include "rzb_conf.h"
#include "rzb_client.h"
#include "rzb_network.h"

#define DEFAULT_DETECT_PORT 6033
#define DEFAULT_DETECT_PORT_S "6033"

int main (int argc, char ** argv)
{
    static const struct option long_options[] =
    {
        {"conf",required_argument, NULL, 'c'},
        {NULL, 0, NULL, 0}
    };

    int optId; /* holds the option index for getopt*/
    const char *configFile = NULL;
    int option_index = 0;

    while (1)
    {
        optId = getopt_long(argc, argv, "c:", long_options, &option_index);

        if (optId == -1)
            break;

        switch (optId)
        {
            case 'c':
                configFile = optarg;
                break;
            case '?':  /* getopt errors */
                break;
            default:
                break;
        }
    }

    nuggetServer(configFile);

    return 0;
}
