#include <arpa/inet.h>
#include <getopt.h>

#include "config.h"
#include "rzb_intel_global.h"
#include "rzb_intel_api.h"
#include "rzb_global.h"
#include "rzb_network.h"
#include "rzb_client.h"
#include "rzb_conf.h"
#include "rzb_api.h"

static char SRC_IP[] = "192.168.1.6";
static char DST_IP[] = "204.11.59.2";
static char MAIL_FROM[] = "molney@sourcefire.com";
static char RCPT_TO[] = "mwatchinski@sourcefire.com";
static char SUBJECT[] = "Hey, check out this new 0-day!";
static char MSG_FROM[] = "matt.olney@sourcefire.com";
static char MSG_TO[] = "matthew.watchinski@sourcefire.com";
static char BODY_TXT[] = "Wow, man, this is awesome!";
static char DATE_TXT[] = "2010-07-15 14:38:49";
static unsigned char ATTACHMENT1[] = "DUDE DUDE DUDE!";
static char ATTACHMENT1_NAME[] = "Dude.txt";
static unsigned char ATTACHMENT2[] = "I GOT NO NAME";

int main(int argc, char ** argv)
{
    const BASE_MAIL_DATA mail =
    {
        .src_ip = SRC_IP,
        .dst_ip = DST_IP,
        .mail_from = MAIL_FROM,
        .rcpt_to = RCPT_TO,
        .subject = SUBJECT,
        .msg_from = MSG_FROM,
        .msg_to = MSG_TO,
    };
    unsigned mail_id;

    static const struct option long_options[] =
    {
        {"conf",required_argument, NULL, 'c'},
        {NULL, 0, NULL, 0}
    };

    int optId; /* holds the option index for getopt*/
    const char *configFile = "rzb.conf";
    int option_index = 0;

    while (1)
    {
        optId = getopt_long(argc, argv, "c:", long_options, &option_index);

        if (optId == -1)
            break;

        switch (optId)
        {
            case 'c':
                configFile = optarg;
                break;
            case '?':  /* getopt errors */
                break;
            default:
                break;
        }
    }

    readConfig(&nrtconfig, configFile);

    printf("<---Intel Nugget--->\n");
    printf("Src ip: %s\n", mail.src_ip);
    printf("Dst ip: %s\n", mail.dst_ip);
    printf("<----Intel API---->\n");

    sendNewMail(&mail, &mail_id);
    printf("Mail ID is %u\n", mail_id);
    printf("<---Mail Submitted: %u--->\n", mail_id);
    printf("<BODY>\n");
    addMailData(BODY, BODY_TXT, mail_id);
    printf("<MSG_ID>\n");
    addMailData(MSG_ID, BODY_TXT, mail_id);
    printf("<MIME_VER>\n");
    addMailData(MIME_VER, BODY_TXT, mail_id);
    printf("<LANGUGAGE>\n");
    addMailData(LANGUAGE, BODY_TXT, mail_id);
    printf("<MAILER>\n");
    addMailData(MAILER, BODY_TXT, mail_id);
    printf("<THREAD_IDX>\n");
    addMailData(THREAD_IDX, BODY_TXT, mail_id);
    printf("<XBLOCK>\n");
    addMailData(XBLOCK, BODY_TXT, mail_id);
    printf("<HEADER_DATE>\n");
    addMailData(HEADER_DATE, DATE_TXT, mail_id);
    printf("<---ATTACHMENTS--->\n");
    printf("<---Named--->\n");
    sendMailAttachment(sizeof(ATTACHMENT1) - 1, ATTACHMENT1, ANY_DATA_API, ATTACHMENT1_NAME, mail_id);
    printf("<---Unnamed--->\n");
    sendMailAttachment(sizeof(ATTACHMENT2) - 1, ATTACHMENT2, ANY_DATA_API, NULL, mail_id);
    printf("<---END ATTACHMNETS--->\n");
    printf("<--Run Complete-->\n");

    return 0;
}
